
 set DPPEnable 1

    set A32Base [third [split $AddressData :]]

   DefineRegister $Module xVME ConfigReload        "-a $A32Base -w 32 -o 0xef34 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Clear               "-a $A32Base -w 32 -o 0xef28 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Reset               "-a $A32Base -w 32 -o 0xef24 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Scratch             "-a $A32Base -w 32 -o 0xef20 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FlashEnable         "-a $A32Base -w 32 -o 0xef2c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FlashData           "-a $A32Base -w 32 -o 0xef30 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME BLTEventNum         "-a $A32Base -w 32 -o 0xef1c -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME VMEBaseAddress      "-a $A32Base -w 32 -o 0xef10 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME MCSTBaseAddress     "-a $A32Base -w 32 -o 0xef0c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Status              "-a $A32Base -w 32 -o 0xef04 -p ro -d 32 -l 3 -b 0 -z x"
   DefineRegister $Module xVME Control             "-a $A32Base -w 32 -o 0xef00 -p rw -d 32 -l 0 -b 0 -z d"

   DefineRegister $Module xVME AnalogMon           "-a $A32Base -w 32 -o 0x8150 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME EventSize           "-a $A32Base -w 32 -o 0x814c -p ro -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME MonitorMode         "-a $A32Base -w 32 -o 0x8144 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME BoardInfo           "-a $A32Base -w 32 -o 0x8140 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME MonitorDAC          "-a $A32Base -w 32 -o 0x8138 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME EventsStored        "-a $A32Base -w 32 -o 0x812c -p ro -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME DownSample          "-a $A32Base -w 32 -o 0x8128 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME FPGARev             "-a $A32Base -w 32 -o 0x8124 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Enable              "-a $A32Base -w 32 -o 0x8120 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPIOControl         "-a $A32Base -w 32 -o 0x811c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPIOData            "-a $A32Base -w 32 -o 0x8118 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPTrigOutEnable     "-a $A32Base -w 32 -o 0x8110 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME TrigSrcEnable       "-a $A32Base -w 32 -o 0x810c -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME SoftTrig            "-a $A32Base -w 32 -o 0x8108 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME AcqStatus           "-a $A32Base -w 32 -o 0x8104 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME AcqControl          "-a $A32Base -w 32 -o 0x8100 -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME CustomSize          "-a $A32Base -w 32 -o 0x8020 -p rw -d 32 -l 0 -b 0 -z d"

if {$DPPEnable} {
   DefineRegister $Module xVME SoftwareSyncReset   "-a $A32Base -w 32 -o 0x813c -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME FPDACPulser         "-a $A32Base -w 32 -o 0x8154 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME FirmWareLicense     "-a $A32Base -w 32 -o 0x8158 -p ro -d 32 -l 0 -b 0 -z x"
}

   DefineRegister $Module xVME BufferFree          "-a $A32Base -w 32 -o 0x8010 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME BufferOrg           "-a $A32Base -w 32 -o 0x800c -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME ConfigClr           "-a $A32Base -w 32 -o 0x8008 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME ConfigSet           "-a $A32Base -w 32 -o 0x8004 -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME Config              "-a $A32Base -w 32 -o 0x8000 -p rw -d 32 -l 0 -b 0 -z x"

if {$DPPEnable} {
      DefineRegister $Module xVME DPP_PAR1     "-a $A32Base -w 32 -o 0x8024 -p wo -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR2     "-a $A32Base -w 32 -o 0x8028 -p wo -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR3     "-a $A32Base -w 32 -o 0x802c -p wo -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR4     "-a $A32Base -w 32 -o 0x8030 -p wo -d 32 -l 0 -b 0 -z x"
} else {
      DefineRegister $Module xVME ZS_NSAMP   "-a $A32Base -w 32 -o 0x8028 -p wo -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME ZS_THRES   "-a $A32Base -w 32 -o 0x8024 -p wo -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME OUThresh   "-a $A32Base -w 32 -o 0x8084 -p wo -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Thresh     "-a $A32Base -w 32 -o 0x8080 -p wo -d 32 -l 0 -b 0 -z d"
}

   DefineRegister $Module xVME ADCConfig    "-a $A32Base -w 32 -o 0x809c -p wo -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME DAC          "-a $A32Base -w 32 -o 0x8098 -p wo -d 32 -l 0 -b 0 -z x"
#   DefineRegister $Module xVME PostTrig     "-a $A32Base -w 32 -o 0x8014 -p wo -d 32 -l 0 -b 0 -z d"
#   DefineRegister $Module xVME Scratch      "-a $A32Base -w 32 -o 0xef20 -p rw -d 32 -l 0 -b 0 -z d"
   DefineRegister $Module xVME PostTrig     "-a $A32Base -w 32 -o 0x8014 -p wo -d 32 -l 0 -b 0 -z d"

   for {set ijk 0} {$ijk < 8} {incr ijk} {
      DefineRegister $Module xVME ADCConfig.Ch$ijk "-a $A32Base -w 32 -o [expr 0x109c+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DAC.Ch$ijk       "-a $A32Base -w 32 -o [expr 0x1098+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
#      DefineRegister $Module xVME ChPostTrig$ijk  "-a $A32Base -w 32 -o [expr 0x1014+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME PostTrig.Ch$ijk  "-a $A32Base -w 32 -o 0xef20 -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Bufs.Ch$ijk      "-a $A32Base -w 32 -o [expr 0x1094+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME FPGARev.Ch$ijk   "-a $A32Base -w 32 -o [expr 0x108c+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME Status.Ch$ijk    "-a $A32Base -w 32 -o [expr 0x1088+($ijk*0x100)] -p ro -d 32 -l 0 -b 0 -z x"
if {$DPPEnable} {
   DefineRegister $Module xVME DPP_PAR1.Ch$ijk "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module xVME DPP_PAR1.Ch$ijk.RiseTime  "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 8 -b 0 -z d"
   DefineRegister $Module xVME DPP_PAR1.Ch$ijk.AvWindow  "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 6 -b 8 -z d"
   DefineRegister $Module xVME DPP_PAR1.Ch$ijk.PileUpRej "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 1 -b 14 -z d"
   DefineRegister $Module xVME DPP_PAR1.Ch$ijk.DecayTime "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 16 -b 16 -z d"
      DefineRegister $Module xVME DPP_PAR2.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR2.Ch$ijk.TrapRiseTime  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 10 -b 0 -z d"
      DefineRegister $Module xVME DPP_PAR2.Ch$ijk.TrapFlatTop  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 10 -b 12 -z d"
      DefineRegister $Module xVME DPP_PAR2.Ch$ijk.PeakValueShift  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 6 -b 24 -z d"
      DefineRegister $Module xVME DPP_PAR2.Ch$ijk.BaseLineMean  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 2 -b 30 -z d"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk.Threshold  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 14 -b 0 -z d"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk.Decimation  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 2 -b 14 -z d"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk.FlatTopDelay  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 11 -b 16 -z d"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk.PeakAvWin  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 2 -b 28 -z d"
      DefineRegister $Module xVME DPP_PAR3.Ch$ijk.DigitalGain  "-a $A32Base -w 32 -o [expr 0x102c+($ijk*0x100)] -p rw -d 32 -l 2 -b 30 -z d"
      DefineRegister $Module xVME DPP_PAR4.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x1030+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME DPP_PAR4.Ch$ijk.TrigWinOffset  "-a $A32Base -w 32 -o [expr 0x1030+($ijk*0x100)] -p rw -d 32 -l 9 -b 0 -z d"
      DefineRegister $Module xVME DPP_PAR4.Ch$ijk.TrigWinWidth  "-a $A32Base -w 32 -o [expr 0x1030+($ijk*0x100)] -p rw -d 32 -l 3 -b 9 -z d"
} else {
      DefineRegister $Module xVME ZS_NSAMP.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x1028+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME ZS_THRES.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x1024+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z x"
      DefineRegister $Module xVME OUThresh.Ch$ijk  "-a $A32Base -w 32 -o [expr 0x1084+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
      DefineRegister $Module xVME Thresh.Ch$ijk    "-a $A32Base -w 32 -o [expr 0x1080+($ijk*0x100)] -p rw -d 32 -l 0 -b 0 -z d"
}
   }

   DefineRegister $Module xVME DataItem            "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -l 0 -b 0 -z x"
   DefineRegister $Module bVME Output_Buffer         "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -z x -l 64"



puts "Defined $Module with DPP enabled"
